;Technoid game 
;=========================================================================
Graphics 640,480,32,2
SetBuffer BackBuffer()

;globals & constants
Global velocity_timer=0

;type declaration
Type Player
	Field x#,y#
	Field image
End Type

Type Cannonball
	Field x#,y#
	Field dirx#,diry#
	Field image
End Type

Type Block
	Field x,y
	Field exist
	Field image
End Type

;defining types
AutoMidHandle 1
Global ball.Cannonball=New Cannonball
ball\image=LoadImage("images/ball1.png")
MaskImage ball\image,255,255,255
ball\x=320:ball\y=240
ball\dirx=0:ball\diry=3

Global paddle.Player=New Player
paddle\image=LoadImage("images/paddle1.png")
paddle\x=320:paddle\y=430

BlockInit(8,8)

;[Block]
;main loop
While Not KeyHit(1)
	Cls
	
	Keycheck()
	BallUpdate()
	BallCollidePaddle()
	BallCollideWalls()
	BallCollideBlocks()
	
	DrawImage paddle\image,paddle\x,paddle\y
	DrawImage ball\image,ball\x,ball\y
	
	Text 10,10,"ball\dirx = "+ball\dirx+" ball\diry = "+ball\diry
	Text 10,20,"bounce_timer = "+velocity_timer
	
	Flip
Wend
End
;main loop End
;[End Block]

Function Keycheck()
	;keyboard check for paddle
	If KeyDown(203) And paddle\x >= 60 Then 
		paddle\x=paddle\x+-3
	ElseIf KeyDown(205) And paddle\x <= 580 Then 
		paddle\x=paddle\x+3
	EndIf
End Function

Function BallUpdate()
	;sets ball velocity
	ball\y=ball\y+ball\diry
	ball\x=ball\x+ball\dirx
	;doesnt let ball speed fall too low or climb too high
	If Abs(ball\diry)>8 Then ball\diry=Sgn(ball\diry)*8
	If Abs(ball\diry)<2 Then ball\diry=Sgn(ball\diry)*2
	If Abs(ball\dirx)>6 Then ball\dirx=Sgn(ball\dirx)*6
	If Abs(ball\dirx)<2 Then ball\dirx=Sgn(ball\dirx)*2
	;ball velocity
	If MilliSecs()>=velocity_timer+50 And ball\y <300 Then 
		ball\diry=Sgn(ball\diry)*(Abs(ball\diry)-(-Sgn(ball\diry)*.1))
		velocity_timer=MilliSecs()
	EndIf
End Function

Function BallCollidePaddle()
	;checks if ball collides with paddle
	If ImagesCollide(ball\image,ball\x,ball\y,0,paddle\image,paddle\x,paddle\y,0)
		ball\diry = -Abs(ball\diry) ;bounce ball off the paddle
		velocity_timer=MilliSecs() ;moment when ball bounced
		If ball\x < paddle\x And ball\x > paddle\x-48 Then
			ball\dirx = 2*(-(paddle\x-ball\x)/48)
		ElseIf ball\x > paddle\x And ball\x < paddle\x+48 Then
			ball\dirx = 2*(-(paddle\x-ball\x)/48)
		ElseIf ball\x=paddle\x Then
			ball\dirx=0
		EndIf
		
	EndIf
End Function

Function BallCollideWalls()
;checks if ball collides with screen borders
	;checks for sidewalls
	If ball\x<=20 Or ball\x>=620 Then
		ball\dirx=-ball\dirx
	EndIf
	
	;checks for ceiling
	If ball\y<=20 Then
		ball\diry=-ball\diry
	EndIf
	
	;checks for bottom
	If ball\y>=480 Then
		ball\y=240:ball\x=320:ball\dirx=0:ball\diry=2
	EndIf
End Function

Function BlockInit(r,c)
	;creates blocks when level starts
	For i=1 To r
		For j=1 To c
			block.Block=New Block
			block\image=LoadImage("images/block1.png")
			block\exist=1
			block\x=30+64*i
			block\y=30+32*j
		Next
	Next
End Function

Function BallCollideBlocks()
	;draws and destroys blocks when collided with ball
	For block.Block=Each Block
		DrawImage block\image,block\x,block\y
		If ImagesCollide(ball\image,ball\x,ball\y,0,block\image,block\x,block\y,0) Then
			ball\diry=-Abs(ball\diry+.5)
			Delete block.Block
		EndIf
	Next
End Function
;~IDEal Editor Parameters:
;~F#9#3F
;~C#Blitz3D